package com.scalangular.f1.league.v2.usecases.crud

import arrow.core.*
import arrow.fx.coroutines.parTraverse
import arrow.fx.coroutines.parZip
import com.scalangular.f1.league.v2.entities.DriverRaceResult
import com.scalangular.f1.league.v2.entities.F1Driver
import com.scalangular.f1.league.v2.entities.Race
import com.scalangular.f1.league.v2.generated.transfer.entitys.RaceResult
import com.scalangular.f1.league.v2.ports.output.LeagueExistsPort
import com.scalangular.f1.league.v2.ports.output.LoggerDelegate
import com.scalangular.f1.league.v2.repositories.DriverRaceResultRepository
import com.scalangular.f1.league.v2.repositories.DriverRepository
import com.scalangular.f1.league.v2.repositories.RaceRepository
import com.scalangular.f1.league.v2.usecases.common.AutogenerateDNSForRaceResultUseCase
import com.scalangular.f1.league.v2.usecases.common.AutogenerateDNSForRaceResultUseCase.AutogenerateDNSForRaceResultCommand
import com.scalangular.f1.league.v2.usecases.common.BuildRaceResultsUseCase
import com.scalangular.f1.league.v2.usecases.common.DefaultBuildRaceResultsUseCase
import com.scalangular.f1.league.v2.usecases.crud.GetRaceResultsUseCase.GetRaceResultsCommand.*
import com.scalangular.f1.league.v2.usecases.crud.GetRaceResultsUseCase.GetRaceResultsError
import com.scalangular.f1.league.v2.usecases.crud.GetRaceResultsUseCase.GetRaceResultsError.*
import com.scalangular.f1.league.v2.usecases.crud.GetRacesUseCase.GetRacesCommand
import com.scalangular.f1.league.v2.usecases.crud.GetRacesUseCase.GetRacesError
import kotlinx.coroutines.Deferred
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.async
import kotlinx.coroutines.withContext
import com.scalangular.f1.league.v2.generated.transfer.entitys.Race as EntityRaces

class DefaultGetRaceResultsUseCase(
    private val getRacesUseCase: GetRacesUseCase,
    private val driverRepository: DriverRepository,
    private val leagueExistsPort: LeagueExistsPort,
    private val raceRepository: RaceRepository,
    private val driverRaceResultRepository: DriverRaceResultRepository,
    private val buildRaceResultsUseCase: DefaultBuildRaceResultsUseCase,
    private val autogenerateDNSForRaceResultUseCase: AutogenerateDNSForRaceResultUseCase
) : GetRaceResultsUseCase {

    private val logger by LoggerDelegate()

    override suspend fun getRaceResults(command: GetRaceResultsUseCase.GetRaceResultsCommand): Either<GetRaceResultsError, List<RaceResult>> {
        return when (command) {
            is GetRaceResultsForDriverCommand -> getRaceResultsForDriver(command)
            is GetRaceResultsForLeagueCommand -> getRaceResultsForLeague(command)
            is GetRaceResultsForRaceCommand -> getRaceResultsForRace(command)
        }
    }

    private fun getRaceResultsForRace(command: GetRaceResultsForRaceCommand) =
        when {
            (raceRepository.existsById(command.raceId)) -> {
                val race: Race = raceRepository.getRaceByRaceId(command.raceId)!!
                val results: List<DriverRaceResult> = driverRaceResultRepository.getAllByRaceRaceId(race.raceId!!)
                val drivers = driverRepository.getAllByLeagueLeagueId(command.leagueId)
                listOf(buildRaceResult(race, results, drivers)).right()
            }
            else -> {
                RaceNotFoundError.left()
            }
        }

    private suspend fun getRaceResultsForLeague(command: GetRaceResultsForLeagueCommand): Either<GetRaceResultsError, List<RaceResult>> =
        when {
            !leagueExistsPort.leagueExists(command.leagueId) -> {
                LeagueNotFoundError.left()
            }
            else -> {
                getRacesResultsForLeague(command).mapLeft { RaceNotFoundError }
            }
        }

    private fun getRaceResultsForDriver(command: GetRaceResultsForDriverCommand): Either<GetRaceResultsError, List<RaceResult>> =
        when {
            !leagueExistsPort.leagueExists(command.leagueId) -> LeagueNotFoundError.left()
            driverRepository.existsByDriverId(command.driverId) -> buildRaceResultsForDriver(command).mapLeft { RaceNotFoundError }
            else -> DriverNotFoundError.left()
        }

    private fun buildRaceResultsForDriver(command: GetRaceResultsForDriverCommand): Either<GetRacesError, List<RaceResult>> {
        val driverRaceResults: List<DriverRaceResult> =
            driverRaceResultRepository.getAllByF1DriverDriverId(command.driverId)
        val drivers = driverRepository.getAllByLeagueLeagueId(command.leagueId)
        val eitherRaces: Either<GetRacesError, List<EntityRaces>> = getRacesUseCase.getRaces(
            GetRacesCommand(command.leagueId)
        )

        return eitherRaces.map { races ->
            races.map { race ->
                val raceFromDb = raceRepository.getRaceByRaceId(race.raceId!!)!!
                buildRaceResult(raceFromDb, driverRaceResults, drivers)
            }
        }
    }

    private suspend fun getRacesResultsForLeague(command: GetRaceResultsForLeagueCommand): Either<GetRacesError, List<RaceResult>> =
        withContext(Dispatchers.Default) {
            logger.debug("outer possibleRaces before")

            val (possibleRaces, drivers) = parZip(
                Dispatchers.IO,
                {
                    logger.debug("inner possibleRaces before")
                    val races = getRacesUseCase.getRaces(
                        GetRacesCommand(command.leagueId)
                    )
                    logger.debug("inner possibleRaces after")
                    races
                },
                {
                    logger.debug("inner driver before")
                    val drivers = driverRepository.getAllByLeagueLeagueId(command.leagueId)
                    logger.debug("inner driver after")
                    drivers
                }
            ) { possibleRaces, drivers -> Pair(possibleRaces, drivers) }

            possibleRaces.map { races ->
                val maxRace: Option<Int> = command.racePositionIndex.map { raceId ->
                    races.findLast { it.raceId == raceId }?.racePositionIndex ?: Int.MIN_VALUE
                }

                races.filter { race ->
                    racePositionIndexFilter(maxRace, race)
                }
                    .parTraverse(Dispatchers.Default) { race: com.scalangular.f1.league.v2.generated.transfer.entitys.Race ->
                        logger.debug("loading raceresults for race ${race.raceId} async")
                        val raceResults =
                            async(Dispatchers.IO) { driverRaceResultRepository.getAllByRaceRaceId(raceId = race.raceId!!) }
                        logger.debug("loading full race for race ${race.raceId} async")
                        val dbRace: Deferred<Race?> =
                            async(Dispatchers.IO) { raceRepository.getRaceByRaceId(race.raceId!!) }
                        buildRaceResult(dbRace.await()!!, raceResults.await(), drivers)
                    }.toList()
            }
        }

    private fun racePositionIndexFilter(
        maxRace: Option<Int>,
        race: com.scalangular.f1.league.v2.generated.transfer.entitys.Race,
    ) = when (maxRace) {
        None -> true
        is Some -> (race.racePositionIndex ?: Int.MAX_VALUE) <= maxRace.value
    }

    private fun buildRaceResult(
        race: Race,
        driverRaceResults: List<DriverRaceResult>,
        allDrivers: List<F1Driver>
    ): RaceResult {
        logger.debug("building raceresults for race ${race.raceId}")
        val raceResults = buildRaceResultsUseCase.buildRaceResult(
            BuildRaceResultsUseCase.BuildRaceResultCommand(
                race,
                driverRaceResults
            )
        )

        return autogenerateDNSForRaceResultUseCase.addDNSToRaceResult(
            AutogenerateDNSForRaceResultCommand(
                raceResults,
                allDrivers
            )
        )
    }
}
